<?php
//---------------------------------------------------------------------------------------------------------------------
//
//   DUMP PLUGIN FOR XASECO
//
//---------------------------------------------------------------------------------------------------------------------
// Purpose ..... Responds to a /dump chat command by generating a json stream containing the $aseco variable
// Date ........ 2017-03-12
// Author ...... Tavernicole (tavernicole@free.fr)
// Origin ...... Original plugin x_dump by reaby
//---------------------------------------------------------------------------------------------------------------------



Aseco::addChatCommand('dump', 'dump the contents of the aseco variable');


// OUTPUT_FILE is the path to save the results into, from the XAseco folder
define ("OUTPUT_FILE", "c:\\Inetpub\\wwwRoot\\xaseco_explorer\\xaseco2.js");



//---------------------------------------------------------------------------------------------------------------------
// Function called by XAseco when the /dump command is issued

function chat_dump($aseco, $command) {
	if(0==strlen($command['params']))
		file_put_contents(OUTPUT_FILE, '{"aseco":'.dump($aseco).'}');
	else {
		global ${$command['params']};
		file_put_contents(OUTPUT_FILE, '{"'.$command['params'].'":'.dump(${$command['params']}).'}');
	}
}



//---------------------------------------------------------------------------------------------------------------------
// Recursive dumping function

function dump($element) {
	//try to use json_encode
	$r = json_encode($element);
	if($r) {
		//success, return the json stream
		return str_replace(array('<', '>'), array('&lt;', '&gt;'), $r);
	} else {
		//json_encode failed.
		if (is_object($element)) {
			//if the element is an object
			$r = "";
			foreach($element as $key => $value) {
				//dump all the properties
				$r .= (strlen($r)==0)?"{":",";
				$r .= "\"".$key."\":".dump($value);
			}
			return $r."}";
		} elseif (is_assoc($element)) {
			//if the element is an associative array
			$r = "";
			foreach($element as $key => $value) {
				//dump the elements contained in the array
				$r .= (strlen($r)==0)?"[":",";
				$r .= "\"".$key."\":".dump($value);
			}
			return $r."]";
		} elseif (is_array($element)) {
			//if the element is a non-associative array
			$r = "";
			foreach($element as $value) {
				$r .= (strlen($r)==0)?"[":",";
				$r .= dump($value);
			}
			return $r."]";
		} else {
			//otherwise: element is not a value, not an object, not an array
			return "\"???\"";
		}
	}
}



//---------------------------------------------------------------------------------------------------------------------
// Checks if the paramater is an associative array

function is_assoc($var) {
	return is_array($var) && array_diff_key($var,array_keys(array_keys($var)));
}



//---------------------------------------------------------------------------------------------------------------------
?>